searchNodes=[{"doc":"NestedMap provides tools to treat nested maps (that came as a surprise), notably: accessing nested values with a list of keys flatting a nested map to a list of pairs of list of keys and values nested merging Complexity When describing complexities we assume n total entries (length of flattened list) with a maximum depth of k (maximum length of key list). We do not define a bound other than O(n) for the number of elements of depth k and therefore define m = n*k Accessing Is of complexity O(k) of course Basic interface iex(0)&gt; fetch ( %{ } , :a ) # not found :error iex(1)&gt; fetch ( %{ b : 2 } , :a , 42 ) # default { :ok , 42 } iex(2)&gt; fetch ( %{ a : 2 } , :a , 42 ) # default { :ok , 2 } iex(3)&gt; fetch ( %{ a : 41 } , :a ) # found { :ok , 41 } iex(4)&gt; fetch! ( %{ a : 41 } , :a ) 41 iex(5)&gt; fetch! ( %{ } , :a , 42 ) 42 iex(6)&gt; try do ...(6)&gt; fetch! ( %{ } , :a ) ...(6)&gt; rescue ...(6)&gt; NestedMap.Error -&gt; :caught ...(6)&gt; end :caught Applied to nests iex(7)&gt; map = %{ ...(7)&gt; a : 1 , ...(7)&gt; b : %{ ...(7)&gt; c : %{ ...(7)&gt; a : 100 , ...(7)&gt; b : 200 ...(7)&gt; } , ...(7)&gt; d : 40 } } ...(7)&gt; { fetch ( map , [ :b , :c ] ) , fetch ( map , [ :b , :c , :b ] ) , fetch! ( map , [ :b , :x ] , :not_found ) } { { :ok , %{ a : 100 , b : 200 } } , { :ok , 200 } , :not_found } Flattening The complexity is O(m) iex(8)&gt; flatten ( %{ } ) # empty [ ] iex(9)&gt; flatten ( %{ a : 1 , b : 2 } ) # flat [ { [ :a ] , 1 } , { [ :b ] , 2 } ] iex(10)&gt; map = %{ ...(10)&gt; a : 1 , ...(10)&gt; b : %{ ...(10)&gt; [ &quot;you&quot; , &quot;can&quot; ] =&gt; %{ ...(10)&gt; &quot;do&quot; =&gt; &quot;that&quot; , ...(10)&gt; &quot;if&quot; =&gt; %{ you : :want } ...(10)&gt; } , ...(10)&gt; the_inevitable : 42 } , ...(10)&gt; c : 2 } ...(10)&gt; flatten ( map ) # Be aware that this syntax puts the symbol key ...(10)&gt; # `the_inevitable` before the other keys! [ { [ :a ] , 1 } , { [ :b , :the_inevitable ] , 42 } , { [ :b , [ &quot;you&quot; , &quot;can&quot; ] , &quot;do&quot; ] , &quot;that&quot; } , { [ :b , [ &quot;you&quot; , &quot;can&quot; ] , &quot;if&quot; , :you ] , :want } , { [ :c ] , 2 } ] Accessing flattened elements iex(11)&gt; flattened = ...(11)&gt; [ { [ :a , :a , :a , :a , :b ] , 1 } , ...(11)&gt; { [ :a , :a , :a , :b ] , 1 } , ...(11)&gt; { [ :a , :a , :b ] , 2 } , ...(11)&gt; { [ :a , :b ] , 3 } , ...(11)&gt; { [ :b ] , 4 } ] ...(11)&gt; find ( flattened , [ :a , :a , :b ] ) 2 Deepening The complexity = O(k) * O(n) * the complexity of Map.merge iex(12)&gt; flattened = ...(12)&gt; [ { [ :a , :a , :a , :a , :b ] , 1 } , ...(12)&gt; { [ :a , :a , :a , :b ] , 1 } , ...(12)&gt; { [ :a , :a , :b ] , 2 } , ...(12)&gt; { [ :a , :b ] , 3 } , ...(12)&gt; { [ :b ] , 4 } ] ...(12)&gt; deepen ( flattened ) %{ a : %{ a : %{ a : %{ a : %{ b : 1 } , b : 1 } , b : 2 } , b : 3 } , b : 4 } One can pass a list that does not represent a flattened map iex(13)&gt; impossible = ...(13)&gt; [ { [ :a , :a , :a , :a , :b ] , 1 } , ...(13)&gt; { [ :a , :a , :b ] , 2 } , ...(13)&gt; { [ :a , :a , :b , :b ] , 3 } , # %{a: %{a: %{b: value}}} value was not a map according ...(13)&gt; # to the previous line ...(13)&gt; { [ :a , :b ] , 4 } , ...(13)&gt; { [ :b ] , 5 } ] ...(13)&gt; deepen ( impossible ) # the entry {[:a, :a, :b], 2} will simply be overwritten %{ a : %{ a : %{ a : %{ a : %{ b : 1 } } , b : %{ b : 3 } } , b : 4 } , b : 5 } A consequence of this is that, while this assumption holds for all maps deepen ( flatten ( map ) ) == map the symmetric assumption flatten ( deepen ( list ) ) == list does not, even if list is of the appropriate type, meaning that deepen(list) returns a map. iex(14)&gt; tail = ...(14)&gt; [ { [ :a , :b , :c ] , 1 } , ...(14)&gt; { [ :a , :b ] , 3 } ] ...(14)&gt; deepen ( tail ) %{ a : %{ b : 3 } } ### Merging is now a trivial task as it can be done as follows ( 1 ) flatten lhs and rhs into arrays ( 2 ) make these arrays maps with the compound keys ( 3 ) merge these maps ( 4 ) make the resulting map a flattened array again ( 5 ) deepen this into a map , voilà. here is a short demonstration: iex(15)&gt; a = %{ a : %{ b : 1 , c : 2 } } ...(15)&gt; b = %{ a : %{ b : 2 , d : 3 } } ...(15)&gt; amap = a |&gt; flatten ( ) |&gt; Enum . into ( %{ } ) ...(15)&gt; bmap = b |&gt; flatten ( ) |&gt; Enum . into ( %{ } ) ...(15)&gt; Map . merge ( amap , bmap ) |&gt; flatten ( ) |&gt; Enum . map ( fn { [ keys ] , value } -&gt; { keys , value } end ) |&gt; deepen ( ) %{ a : %{ b : 2 , c : 2 , d : 3 } } of course this is implemented in a convenience function merge which has the complexity of deepen, in our case O(K) * O(S) * Complexity of Map.merge where K = max (k_of_a, k_of_b) &amp;&amp; S = n_of_a + n_of_b iex(16)&gt; a = %{ a : %{ b : 1 , c : %{ d : 2 } } , x : 100 } ...(16)&gt; b = %{ a : %{ b : 3 , c : %{ e : 4 } } , y : 200 } ...(16)&gt; merge ( a , b ) %{ a : %{ b : 3 , c : %{ d : 2 , e : 4 } } , x : 100 , y : 200 } #### Conflict resolution is done as with Map.merge iex(17)&gt; a = %{ a : %{ b : 1 , c : %{ d : 2 } } , x : 100 } ...(17)&gt; b = %{ a : %{ b : 3 , c : %{ e : 4 } } , y : 200 } ...(17)&gt; merge ( a , b , fn _ , lhs , rhs -&gt; lhs + rhs end ) %{ a : %{ b : 4 , c : %{ d : 2 , e : 4 } } , x : 100 , y : 200 } ### Creating nested maps The make_nested_map function supports a normal format iex(18)&gt; make_nested_map ( [ :a , :b , :c ] , 42 ) %{ a : %{ b : %{ c : 42 } } } and one that is adapted to iterate over flattened representations iex(19)&gt; make_nested_map ( { [ :a , :b , :c ] , 42 } ) %{ a : %{ b : %{ c : 42 } } }","ref":"NestedMap.html","title":"NestedMap","type":"module"},{"doc":"","ref":"NestedMap.html#deepen/1","title":"NestedMap.deepen/1","type":"function"},{"doc":"","ref":"NestedMap.html#fetch/2","title":"NestedMap.fetch/2","type":"function"},{"doc":"","ref":"NestedMap.html#fetch/3","title":"NestedMap.fetch/3","type":"function"},{"doc":"","ref":"NestedMap.html#fetch!/2","title":"NestedMap.fetch!/2","type":"function"},{"doc":"","ref":"NestedMap.html#fetch!/3","title":"NestedMap.fetch!/3","type":"function"},{"doc":"","ref":"NestedMap.html#find/2","title":"NestedMap.find/2","type":"function"},{"doc":"","ref":"NestedMap.html#flatten/1","title":"NestedMap.flatten/1","type":"function"},{"doc":"","ref":"NestedMap.html#make_nested_map/1","title":"NestedMap.make_nested_map/1","type":"function"},{"doc":"","ref":"NestedMap.html#make_nested_map/2","title":"NestedMap.make_nested_map/2","type":"function"},{"doc":"","ref":"NestedMap.html#merge/2","title":"NestedMap.merge/2","type":"function"},{"doc":"","ref":"NestedMap.html#merge/3","title":"NestedMap.merge/3","type":"function"},{"doc":"Used by the xtra mix task to generate the latest version in the docs, but also handy for client applications for quick exploration in iex .","ref":"NestedMap.html#version/0","title":"NestedMap.version/0","type":"function"},{"doc":"","ref":"NestedMap.html#t:flattend_map_entry_t/0","title":"NestedMap.flattend_map_entry_t/0","type":"type"},{"doc":"","ref":"NestedMap.html#t:flattened_map_t/0","title":"NestedMap.flattened_map_t/0","type":"type"},{"doc":"","ref":"NestedMap.html#t:maybe/1","title":"NestedMap.maybe/1","type":"type"},{"doc":"","ref":"NestedMap.html#t:ok_t/0","title":"NestedMap.ok_t/0","type":"type"},{"doc":"","ref":"NestedMap.html#t:pair_t/0","title":"NestedMap.pair_t/0","type":"type"},{"doc":"","ref":"NestedMap.html#t:result_t/0","title":"NestedMap.result_t/0","type":"type"},{"doc":"Implements deep access to nested values","ref":"NestedMap.Fetcher.html","title":"NestedMap.Fetcher","type":"module"},{"doc":"","ref":"NestedMap.Fetcher.html#t:flattend_map_entry_t/0","title":"NestedMap.Fetcher.flattend_map_entry_t/0","type":"type"},{"doc":"","ref":"NestedMap.Fetcher.html#t:flattened_map_t/0","title":"NestedMap.Fetcher.flattened_map_t/0","type":"type"},{"doc":"","ref":"NestedMap.Fetcher.html#t:maybe/1","title":"NestedMap.Fetcher.maybe/1","type":"type"},{"doc":"","ref":"NestedMap.Fetcher.html#t:ok_t/0","title":"NestedMap.Fetcher.ok_t/0","type":"type"},{"doc":"","ref":"NestedMap.Fetcher.html#t:pair_t/0","title":"NestedMap.Fetcher.pair_t/0","type":"type"},{"doc":"","ref":"NestedMap.Fetcher.html#t:result_t/0","title":"NestedMap.Fetcher.result_t/0","type":"type"},{"doc":"Flattens a nested map by using an iterative approach, therefore even extremely deeply nested maps can be flattened without stack overflow","ref":"NestedMap.Flattener.html","title":"NestedMap.Flattener","type":"module"},{"doc":"","ref":"NestedMap.Flattener.html#t:flattend_map_entry_t/0","title":"NestedMap.Flattener.flattend_map_entry_t/0","type":"type"},{"doc":"","ref":"NestedMap.Flattener.html#t:flattened_map_t/0","title":"NestedMap.Flattener.flattened_map_t/0","type":"type"},{"doc":"","ref":"NestedMap.Flattener.html#t:maybe/1","title":"NestedMap.Flattener.maybe/1","type":"type"},{"doc":"","ref":"NestedMap.Flattener.html#t:ok_t/0","title":"NestedMap.Flattener.ok_t/0","type":"type"},{"doc":"","ref":"NestedMap.Flattener.html#t:pair_t/0","title":"NestedMap.Flattener.pair_t/0","type":"type"},{"doc":"","ref":"NestedMap.Flattener.html#t:result_t/0","title":"NestedMap.Flattener.result_t/0","type":"type"},{"doc":"","ref":"NestedMap.Types.html","title":"NestedMap.Types","type":"module"},{"doc":"","ref":"Test.Support.RandomMap.html","title":"Test.Support.RandomMap","type":"module"},{"doc":"","ref":"Test.Support.RandomMap.html#rand_flattened_elements/3","title":"Test.Support.RandomMap.rand_flattened_elements/3","type":"function"}]